// Copyright 2001, Jonathan Bachrach.  See file TERMS.

import java.io.*;
import java.util.*;
import antlr.*;

/**
 * Fragment representing integer literal
 * @author  Jonathan Bachrach
 * @author  Keith Playford
 * @version 0.9, 03OCT00
 */
public class IntegerFragment extends LiteralFragment {
    public IntegerFragment(Integer x) { 
	super(makeToken(JavaTokenTypes.NUM_INT, x.toString())); 
    }   
    public IntegerFragment(Token t) { 
	super(t); 
    }   
    public Object getValue() { 
	return new Integer(Integer.parseInt(getText()));
    }
    public Fragment compileTemplate(int depth) {
	return Template.processTemplate
	    (FragmentList.fnil
	     .fpush(Template.substituteIdentifier
		    ("Template.substituteAsInteger"))
	     .fpush(Template.processParens
		    (FragmentList.fnil
		     .fpush(Template.substituteAsInteger((Integer)getValue()))
		     .freverse()))
	     .freverse());
    }
}

