// Copyright 2001, Jonathan Bachrach.  See file TERMS.

import java.io.*;
import java.util.*;
import antlr.*;

/**
 * A leaf fragment representing Java punctuation tokens
 * @author  Jonathan Bachrach
 * @author  Keith Playford
 * @version 0.9, 03OCT00
 */
public class PunctuationFragment extends LeafFragment {
    String text;
    String templateGeneratorName = "substituteIdentifier";
    String matcherName = "matchName";

    public PunctuationFragment(String s) { 
	text  = s; 
	token = makeToken(JavaTokenTypes.IDENT, s); 
    }   

    public PunctuationFragment(Token t) { 
	text  = t.getText(); 
	token = t; 
    }   

    void print(PrettyStream p) { p.print("Punctuation: " + text); }
    void pprint(PrettyStream p, int depth, boolean isCode) { p.print(text); }
    void lprint(PrettyStream p, int depth, boolean isCode) { 
	lseek(p, depth); p.print(text);
    }
    public String toString() { return "#" + text; }
    public Fragment compileTemplate(int depth) {
	if (templateGeneratorName == null)
	    System.out.println("GEN NULL");
	return Template.processTemplate
	    (FragmentList.fnil
	     .fpush(Template.substituteIdentifier("Template." + templateGeneratorName))
	     .fpush(Template.processParens
		    (FragmentList.fnil
		     .fpush(Template.substituteAsString(text))
		     .freverse()))
	     .freverse());
    }
    public Fragment compileSpecialTemplate(int depth) {
	return Template.processTemplate
	    (FragmentList.fnil
	     .fpush(Template.substituteIdentifier("Template." + templateGeneratorName))
	     .fpush(Template.processParens(FragmentList.fnil))
	     .freverse());
    }
    public Expansion generatePatternCode 
	(IdentifierFragment nowVar, IdentifierFragment nextVar) {
	// #{ FragmentList ?nextVar = ?nowVar.?matcherName(); } 
	return Template.processTemplate
	    (FragmentList.fnil
	     .fpush(Template.substituteIdentifier("FragmentList"))
	     .fpush(nextVar)
	     .fpush(Template.substituteIdentifier("="))
	     .fpush(nowVar)
	     .fpush(Template.substituteDot())
	     .fpush(Template.substituteIdentifier(matcherName))
	     .fpush(Template.processParens(FragmentList.fnil))
	     .fpush(Template.substituteSemicolon())
	     .freverse());
    }
}

