// Copyright 2001, Jonathan Bachrach.  See file TERMS.

import java.io.*;
import java.util.*;

/**
 * Lisp symbols which are just interned strings
 * @author  Jonathan Bachrach
 * @author  Keith Playford
 * @version 0.9, 03OCT00
 */
public class Symbol {
    static Hashtable table = new Hashtable();

    String name = null;

    public String getName() { return name; }

    public Symbol(String name) { this.name = name; }

    public static Symbol intern(String x) {
	Object s = table.get(x);
	if (s == null) {
	    Symbol ns = new Symbol(x);
	    table.put(x, ns);
	    return(ns);
	} else
	    return (Symbol)s;
    }

    public String toString() { return "#\"" + name + "\""; }
}

