// Copyright 2001, Jonathan Bachrach.  See file TERMS.

import java.io.*;
import java.util.*;
import antlr.*;

/**
 * A parsed representation of a syntaxSwitch rule
 * @author  Jonathan Bachrach
 * @author  Keith Playford
 * @version 0.9, 03OCT00
 */
public class SyntaxRule {
    public SyntaxRule () { }
    private List patterns           = List.nil;
    private FragmentList statements = FragmentList.fnil;
    public List getPatterns() { return patterns; }
    public FragmentList getStatements() { return statements; }
    public void setPatterns (List patterns) { 
	this.patterns = patterns; 
    }
    public void setStatements (FragmentList statements) { 
	this.statements = statements; 
    }
    public void addPattern (Template pattern) { 
	patterns = patterns.append(List.list(pattern)); 
    }
    public void addStatement (FragmentList statement) { 
	statements = statements.fappend(statement); 
    }
}
